/*                                                                         */
/*  D E T A C H                                                            */
/*                                                                         */
/*                                                                         */
/*  Detach process from controlling terminal -- finger@rz.uni-karlsruhe.de */
/*                                                                         */

#define	DEBUG		0

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>

extern int		errno;
#if !defined(linux) && !defined(__NetBSD__)
extern char		*sys_errlist [];
#endif


int main(argc,argv)
int		argc;
char	**argv;
{
	char	*path;
	char	*cp;

	if (argc<2 || !strcmp (*++argv, "-h")) {
		fputs("Usage: detach [-c|-k] command [parameter ...]\n", stderr);
		fputs("  -c:  close stdin/out/err\n", stderr);
		fputs("  -k:  keep them open\n", stderr);
		fputs("  else reopen them to /dev/null\n", stderr);
		exit(1);
	}

	if (!strcmp (*argv, "-c")) {
		fcntl (0, F_SETFD, 1);
		fcntl (1, F_SETFD, 1);
		fcntl (2, F_SETFD, 1);
		++argv;
	}
	else if (!strcmp (*argv, "-k")) {
		++argv;
	}
	else {
		dup2 (1, 4);
		dup2 (2, 5);
		fcntl (4, F_SETFD, 1);
		fcntl (5, F_SETFD, 1);
		close (0);
		close (1);
		close (2);
		open ("/dev/null", O_RDWR);
		open ("/dev/null", O_RDWR);
		open ("/dev/null", O_RDWR);
	}

	switch (fork()) {
		case -1:
			perror("fork");
			return (1);
		case 0:
			path = *argv;
			if ((cp = strrchr (path, '/')) != NULL)
				*argv = ++cp;
#if DEBUG
			dup2 (4, 1);
			fprintf (stdout, "exec %s: %s %s ...\n",
				path, *argv, argv[1]?argv[1]:"");
			return (0);
#else
			setsid();
			execv(path,argv);
			dup2 (5, 2);
			fprintf (stderr, "detach: can't exec %s - %s (%d)\n",
				path, sys_errlist [errno], errno);
			return(1);
#endif
		default:
			exit (0);
	}
}
